unit bus_stop;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons;



type
  passenger = record
    place, luggage: integer;
    letter: char;
    lug_name: string;
  end;

type
  TForm1 = class(TForm)
    bustype: TRadioGroup;
    Label2: TLabel;
    list_pas: TListBox;
    Label1: TLabel;
    Label3: TLabel;
    changelist_dialog: TOpenDialog;
    list_str: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    go_third: TListBox;
    go_first: TListBox;
    go_second: TListBox;
    landing_btn: TButton;
    changelist_btn: TButton;
    Read_btn: TButton;
    procedure bustypeClick(Sender: TObject);
    procedure changelist_btnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Read_btnClick(Sender: TObject);
    procedure landing_btnClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    max_passengers, N_pas, n_first, n_second, n_third, same_place, place_error: integer;
    pas_group: ARRAY [1..63] of passenger;
    pas_first: ARRAY [1..63] of passenger;
    pas_second: ARRAY [1..63] of passenger;
    pas_third: ARRAY [1..63] of passenger;

  end;
function passenger_lan(var passen: passenger): boolean;
var
  Form1: TForm1;

implementation

{$R *.dfm}

function passenger_lan(var passen: passenger): boolean;
begin
  try
    Case passen.luggage of
      1: begin passen.lug_name:= 'Other'; passen.letter:= '-'; end;
      2: begin passen.lug_name:= 'Big luggage'; passen.letter:= 'B'; end;
      3: begin passen.lug_name:= 'Very big luggage'; passen.letter:= 'A'; end;
    end;
    passenger_lan:= true;
  except
    passenger_lan:= false;
    ShowMessage('    !');
  end;
end;

procedure TForm1.bustypeClick(Sender: TObject);
begin
  if Form1.bustype.ItemIndex = 0 then
  begin
    Form1.max_passengers:= 63;
    Form1.Label3.Caption:= '63';
  end
  else if Form1.bustype.ItemIndex = 1 then
  begin
    Form1.max_passengers:= 47;
    Form1.Label3.Caption:= '47';
  end;
end;

procedure TForm1.changelist_btnClick(Sender: TObject);
begin
  if Form1.changelist_dialog.Execute then Form1.list_str.Text:= Form1.changelist_dialog.FileName;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1.changelist_dialog.FileName:= 'data\default.txt';
  Form1.list_str.Text:= 'data\default.txt';
end;

procedure TForm1.Read_btnClick(Sender: TObject);
Var lst_file: TextFile;
    i, buf, j: integer;

//--------read--------------
begin
  place_error:= 0;
  if Form1.bustype.ItemIndex <> -1 then
  begin
    try
      AssignFile(lst_file, Form1.changelist_dialog.FileName);
      Reset(lst_file);
      ReadLn(lst_file, N_pas);
      for i:= 1 to N_pas do
      begin
        ReadLn(lst_file, pas_group[i].place, pas_group[i].luggage);
        if pas_group[i].place > max_passengers then place_error:= place_error + 1;
      end;
      CloseFile(lst_file);
    except
      ShowMessage('   ' + Form1.changelist_dialog.FileName + #13 + '   [List of passengers]   -.');
      N_pas:= 0;
      Form1.list_pas.Clear;
    end;
    if place_error = 0 then
    begin
      if (N_pas <= max_passengers) AND (N_pas > 0) then
      begin
        Form1.list_pas.Clear;
        for i:= 1 to N_pas do
        begin
          if passenger_lan(pas_group[i]) then
          Form1.list_pas.Items.Add('Place: ' + inttostr(pas_group[i].place) +'  '+ pas_group[i].lug_name + '  Letter: ' + pas_group[i].letter);
        end;
        same_place:= 0;
        {same places}
        for i:= 1 to N_pas do
        begin
          buf:= pas_group[i].place;
          for j:= 1 to N_pas do
          begin
            if (buf = pas_group[j].place) AND (j <> i) then
            begin
              same_place:= same_place + 1;
            end;
          end;
        end;
        {/same places}
        if same_place > 0 then
        begin
          ShowMessage('   !   .');
        end;
      end
      else ShowMessage('  ' +#13+ ' !');
    end
    else ShowMessage('!         !' + #13 + ' : ' + inttostr(place_error));
  end
  else ShowMessage('   [Bus model]');
end;

procedure TForm1.landing_btnClick(Sender: TObject);
Var i: integer;
    
begin
if (place_error = 0) AND (same_place = 0) then
begin
  Form1.go_first.Clear;
  Form1.go_second.Clear;
  Form1.go_third.Clear;
  n_first:= 0; n_second:= 0; n_third:= 0;
  for i:= 1 to N_pas do
  begin
    Case Form1.pas_group[i].luggage of
      3: begin n_first:= n_first + 1; pas_first[n_first]:= pas_group[i]; end;
      2: begin n_second:= n_second + 1; pas_second[n_second]:= pas_group[i]; end;
      1: begin n_third:= n_third + 1; pas_third[n_third]:= pas_group[i]; end;
    end;
  end;
  for i:= 1 to n_first do Form1.go_first.Items.Add('Place: ' + inttostr(pas_first[i].place));
  for i:= 1 to n_second do Form1.go_second.Items.Add('Place: ' + inttostr(pas_second[i].place));
  for i:= 1 to n_third do Form1.go_third.Items.Add('Place: ' + inttostr(pas_third[i].place));
end
else ShowMessage('!    !');

end;

end.
